﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.ComplexEventProcessing.Adapters;
using Microsoft.ComplexEventProcessing;
using System.Threading;

namespace DispatchDemo.InputAdapter1
{
    public class DispatcherTypedPointInput :  TypedPointInputAdapter<TrainRuntimeInfo>
    {
        private DispatcherInputConfig _config;
        private Random random;

        /// <summary>
        /// Construct a stop dispatcher
        /// </summary>
        /// <param name="config">Configuration of this adapter</param>
        public DispatcherTypedPointInput(DispatcherInputConfig config)
        {
            _config = config;
            random = new Random(10);
        }
        public override void Start()
        {
            ProduceEvents();
        }
        public override void Resume()
        {
            ProduceEvents();
        }
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }

        private void ProduceEvents()
        {
            DateTime date = new DateTime(2010,10,10);
            EnqueueCtiEvent(DateTime.Now);
            int count= 0;
            while (true)
            {
                Thread.Sleep(100);
                var pendingEvent = CreateInsertEvent();
                pendingEvent.StartTime = DateTime.Now;
                int line = random.Next() % 3;
                pendingEvent.Payload = new TrainRuntimeInfo
                {
                    ID = Guid.NewGuid().ToString(),
                    CurrentLine = ((TrainLine)(line)).ToString(),
                    attachedStop = Stops.Stop1.ToString(),
                    TargetLine = ((TrainLine)((line+1)%3)).ToString()
                };
                EnqueueOperationResult result = Enqueue(ref pendingEvent);
                EnqueueCtiEvent(DateTime.Now);
                count++;
            }
            
        }

    }
}
