﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.ComplexEventProcessing.Adapters;
using Microsoft.ComplexEventProcessing;
using System.Threading;

namespace DispatchDemo.OutputAdapter1
{
    public class DispacherTypedPointOutput : TypedPointOutputAdapter<TrainRuntimeInfo>
    {
        public DispacherTypedPointOutput(DispatcherOutputConfig config)
        {

        }
        public override void Start()
        {
            ConsumeEvents();
        }
        public override void Resume()
        {
            ConsumeEvents();
        }
        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }

        private void ConsumeEvents()
        {
            PointEvent<TrainRuntimeInfo> currEvent;
            DequeueOperationResult result;
            while (true)
            {
                Thread.Sleep(100);
                result = Dequeue(out currEvent);
                if (result == DequeueOperationResult.Empty)
                {
                    Ready();
                    return;                
                }
                else
                {
                    if (currEvent.EventKind == EventKind.Insert)
                    {
                        Console.WriteLine("Output: " +
                        currEvent.StartTime + " " +
                        currEvent.Payload.ID + " " +
                        currEvent.Payload.TargetLine + " "
                        );                       
                    }
                    ReleaseEvent(ref currEvent);
                }

            }

        }

    }
}
