﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.ComplexEventProcessing.Diagnostics;
using Microsoft.ComplexEventProcessing.Adapters;
using Microsoft.ComplexEventProcessing;
using Microsoft.ComplexEventProcessing.Linq;
using System.ServiceModel;
using DispatchDemo.InputAdapter1;
using DispatchDemo.OutputAdapter1;
using DispatchDemo;
namespace PublishedQueries
{
    class Program
    {
        static void Main(string[] args)
        {
            using (Server server = Server.Connect(new EndpointAddress("http://localhost:8080")))
            {
                foreach (Application app in server.Applications.Values)
                {
                    foreach (Query q in app.Queries.Values)
                    {
                        if (q.ShortName == "FromLineAQuery")
                        {
                            q.Stop();
                            q.Delete();
                        }

                    }
                    foreach (QueryTemplate qt in app.QueryTemplates.Values)
                    {
                        if (qt.ShortName == "FromLineAQuery_Template")
                        {
                            qt.Delete();
                        }
                    }
                }
                var dispatcher = server.Applications["Dispatcher"];
                var filterExampleQuery = dispatcher.Queries["filterExampleQuery"];

                var filterStream = filterExampleQuery.ToStream<TrainRuntimeInfo>();


                var fromStream = from e in filterStream
                                 where e.CurrentLine == "LineA"
                                 select e;
                var fromLineAQuery = fromStream.ToQuery("FromLineAQuery", string.Empty, typeof(DispatcherOutputFactory), new DispatcherOutputConfig(), EventShape.Point, StreamEventOrder.FullyOrdered);
                //var fromLineAQuery = dispatcher.Queries["FromLineAQuery"];
                fromLineAQuery.Start();
            }

        }
    }
}
